(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@ngx-share/core'), require('@ngx-share/button'), require('rxjs'), require('rxjs/operators'), require('@fortawesome/angular-fontawesome')) :
    typeof define === 'function' && define.amd ? define('@ngx-share/buttons', ['exports', '@angular/core', '@angular/common', '@ngx-share/core', '@ngx-share/button', 'rxjs', 'rxjs/operators', '@fortawesome/angular-fontawesome'], factory) :
    (global = global || self, factory((global['ngx-share'] = global['ngx-share'] || {}, global['ngx-share'].buttons = {}), global.ng.core, global.ng.common, global.core$1, global.button, global.rxjs, global.rxjs.operators, global.angularFontawesome));
}(this, (function (exports, core, common, core$1, button, rxjs, operators, angularFontawesome) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var ExpandButton = /** @class */ (function () {
        function ExpandButton(el) {
            this.toggle = new core.EventEmitter();
            el.nativeElement.style.setProperty('--button-color', '#FF6651');
        }
        ExpandButton.ɵfac = function ExpandButton_Factory(t) { return new (t || ExpandButton)(core["ɵɵdirectiveInject"](core.ElementRef)); };
        ExpandButton.ɵcmp = core["ɵɵdefineComponent"]({ type: ExpandButton, selectors: [["expand-button"]], inputs: { moreIcon: "moreIcon", lessIcon: "lessIcon", expanded: "expanded", size: "size" }, outputs: { toggle: "toggle" }, decls: 5, vars: 3, consts: [[1, "sb-wrapper", "sb-expand", "sb-show-icon", 3, "click"], [1, "sb-inner"], [1, "sb-content"], [1, "sb-icon"], [3, "icon"]], template: function ExpandButton_Template(rf, ctx) { if (rf & 1) {
                core["ɵɵelementStart"](0, "button", 0);
                core["ɵɵlistener"]("click", function ExpandButton_Template_button_click_0_listener() { return ctx.toggle.emit(!ctx.expanded); });
                core["ɵɵelementStart"](1, "div", 1);
                core["ɵɵelementStart"](2, "div", 2);
                core["ɵɵelementStart"](3, "div", 3);
                core["ɵɵelement"](4, "fa-icon", 4);
                core["ɵɵelementEnd"]();
                core["ɵɵelementEnd"]();
                core["ɵɵelementEnd"]();
                core["ɵɵelementEnd"]();
            } if (rf & 2) {
                core["ɵɵstyleProp"]("font-size", ctx.size, "px");
                core["ɵɵadvance"](4);
                core["ɵɵproperty"]("icon", ctx.expanded ? ctx.lessIcon : ctx.moreIcon);
            } }, directives: [angularFontawesome.FaIconComponent], encapsulation: 2, changeDetection: 0 });
        return ExpandButton;
    }());
    /*@__PURE__*/ (function () { core["ɵsetClassMetadata"](ExpandButton, [{
            type: core.Component,
            args: [{
                    selector: 'expand-button',
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    template: "\n    <button class=\"sb-wrapper sb-expand sb-show-icon\"\n            [style.fontSize.px]=\"size\"\n            (click)=\"toggle.emit(!expanded)\">\n\n      <div class=\"sb-inner\">\n        <div class=\"sb-content\">\n          <div class=\"sb-icon\">\n            <fa-icon [icon]=\"expanded ? lessIcon : moreIcon\"></fa-icon>\n          </div>\n        </div>\n      </div>\n    </button>\n  "
                }]
        }], function () { return [{ type: core.ElementRef }]; }, { moreIcon: [{
                type: core.Input
            }], lessIcon: [{
                type: core.Input
            }], expanded: [{
                type: core.Input
            }], size: [{
                type: core.Input
            }], toggle: [{
                type: core.Output
            }] }); })();

    function ShareButtons_div_0_share_button_1_Template(rf, ctx) { if (rf & 1) {
        var _r18 = core["ɵɵgetCurrentView"]();
        core["ɵɵelementStart"](0, "share-button", 3);
        core["ɵɵlistener"]("opened", function ShareButtons_div_0_share_button_1_Template_share_button_opened_0_listener($event) { core["ɵɵrestoreView"](_r18); var ctx_r17 = core["ɵɵnextContext"](2); return ctx_r17.opened.emit($event); })("closed", function ShareButtons_div_0_share_button_1_Template_share_button_closed_0_listener($event) { core["ɵɵrestoreView"](_r18); var ctx_r19 = core["ɵɵnextContext"](2); return ctx_r19.closed.emit($event); })("count", function ShareButtons_div_0_share_button_1_Template_share_button_count_0_listener($event) { core["ɵɵrestoreView"](_r18); var ctx_r20 = core["ɵɵnextContext"](2); return ctx_r20.count.emit($event); });
        core["ɵɵelementEnd"]();
    } if (rf & 2) {
        var button_r16 = ctx.$implicit;
        var ctx_r14 = core["ɵɵnextContext"](2);
        core["ɵɵproperty"]("button", button_r16)("theme", ctx_r14.theme)("url", ctx_r14.url)("title", ctx_r14.title)("description", ctx_r14.description)("image", ctx_r14.image)("tags", ctx_r14.tags)("autoSetMeta", ctx_r14.autoSetMeta)("showCount", ctx_r14.showCount)("showIcon", ctx_r14.showIcon)("showText", ctx_r14.showText)("size", ctx_r14.size);
    } }
    function ShareButtons_div_0_expand_button_3_Template(rf, ctx) { if (rf & 1) {
        var _r22 = core["ɵɵgetCurrentView"]();
        core["ɵɵelementStart"](0, "expand-button", 4);
        core["ɵɵlistener"]("toggle", function ShareButtons_div_0_expand_button_3_Template_expand_button_toggle_0_listener($event) { core["ɵɵrestoreView"](_r22); var ctx_r21 = core["ɵɵnextContext"](2); return ctx_r21.updateState({ expanded: $event }); });
        core["ɵɵelementEnd"]();
    } if (rf & 2) {
        var state_r13 = core["ɵɵnextContext"]().$implicit;
        var ctx_r15 = core["ɵɵnextContext"]();
        core["ɵɵproperty"]("expanded", state_r13.expanded)("moreIcon", state_r13.moreIcon)("lessIcon", state_r13.lessIcon)("size", (1 + ctx_r15.size / 20) * 14);
    } }
    function ShareButtons_div_0_Template(rf, ctx) { if (rf & 1) {
        core["ɵɵelementStart"](0, "div");
        core["ɵɵtemplate"](1, ShareButtons_div_0_share_button_1_Template, 1, 12, "share-button", 1);
        core["ɵɵelementStart"](2, "div");
        core["ɵɵtemplate"](3, ShareButtons_div_0_expand_button_3_Template, 1, 4, "expand-button", 2);
        core["ɵɵelementEnd"]();
        core["ɵɵelementEnd"]();
    } if (rf & 2) {
        var state_r13 = ctx.$implicit;
        var ctx_r12 = core["ɵɵnextContext"]();
        core["ɵɵclassMapInterpolate1"]("sb-group sb-", ctx_r12.theme, "");
        core["ɵɵadvance"](1);
        core["ɵɵproperty"]("ngForOf", state_r13.selectedButtons);
        core["ɵɵadvance"](1);
        core["ɵɵclassMapInterpolate1"]("sb-button sb-", ctx_r12.theme, "");
        core["ɵɵadvance"](1);
        core["ɵɵproperty"]("ngIf", state_r13.shownCount < state_r13.userButtons.length);
    } }
    var ShareButtons = /** @class */ (function () {
        function ShareButtons(_share) {
            this._share = _share;
            this._state$ = new rxjs.BehaviorSubject({
                includedButtons: [],
                excludedButtons: [],
                userButtons: [],
                selectedButtons: [],
                expanded: true,
                shownCount: Object.keys(core$1.SHARE_BUTTONS).length
            });
            this._configSub$ = rxjs.Subscription.EMPTY;
            this.theme = this._share.config.theme;
            /** Show buttons icons */
            this.showIcon = true;
            /** Show buttons text */
            this.showText = false;
            /** Show sharing count */
            this.showCount = false;
            /** Buttons size */
            this.size = 0;
            /** Share count event */
            this.count = new core.EventEmitter();
            /** Share dialog opened event */
            this.opened = new core.EventEmitter();
            /** Share dialog closed event */
            this.closed = new core.EventEmitter();
        }
        Object.defineProperty(ShareButtons.prototype, "includedButtons", {
            set: function (includedButtons) {
                this.updateState({ includedButtons: includedButtons });
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButtons.prototype, "excludedButtons", {
            set: function (excludedButtons) {
                this.updateState({ excludedButtons: excludedButtons });
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButtons.prototype, "shownButtons", {
            set: function (shownCount) {
                this.updateState({ shownCount: shownCount });
            },
            enumerable: true,
            configurable: true
        });
        ShareButtons.prototype.ngOnInit = function () {
            var _this = this;
            this.state$ = this._state$.pipe(operators.map(function (state) {
                // Use component include buttons, otherwise fallback to global include buttons
                var includedButtons = state.includedButtons.length ? state.includedButtons : state.userButtons;
                var userButtons = includedButtons.filter(function (btn) { return state.excludedButtons.indexOf(btn) < 0; });
                var selectedButtons = userButtons.slice(0, state.expanded ? userButtons.length : state.shownCount);
                return {
                    userButtons: userButtons,
                    selectedButtons: selectedButtons,
                    expanded: state.expanded,
                    shownCount: state.shownCount,
                    moreIcon: state.moreIcon,
                    lessIcon: state.lessIcon
                };
            }));
            // Subscribe to share buttons config changes, This updates the component whenever a new button is added
            this._configSub$ = this._share.config$.subscribe(function (config) {
                // Use global include buttons, otherwise fallback to all buttons
                var includedButtons = config.include.length ? config.include : Object.keys(core$1.SHARE_BUTTONS);
                var userButtons = includedButtons.filter(function (btn) { return config.exclude.indexOf(btn) < 0; });
                _this.updateState({
                    userButtons: userButtons,
                    expanded: false,
                    moreIcon: config.moreButtonIcon,
                    lessIcon: config.lessButtonIcon
                });
            });
        };
        ShareButtons.prototype.ngOnDestroy = function () {
            this._configSub$.unsubscribe();
            this._state$.complete();
        };
        ShareButtons.prototype.updateState = function (state) {
            this._state$.next(__assign(__assign({}, this._state$.value), state));
        };
        ShareButtons.ɵfac = function ShareButtons_Factory(t) { return new (t || ShareButtons)(core["ɵɵdirectiveInject"](core$1.ShareService)); };
        ShareButtons.ɵcmp = core["ɵɵdefineComponent"]({ type: ShareButtons, selectors: [["share-buttons"]], inputs: { theme: "theme", includedButtons: ["include", "includedButtons"], excludedButtons: ["exclude", "excludedButtons"], shownButtons: ["show", "shownButtons"], url: "url", title: "title", description: "description", image: "image", tags: "tags", autoSetMeta: "autoSetMeta", showIcon: "showIcon", showText: "showText", showCount: "showCount", size: "size" }, outputs: { count: "count", opened: "opened", closed: "closed" }, decls: 2, vars: 3, consts: [[3, "class", 4, "ngIf"], [3, "button", "theme", "url", "title", "description", "image", "tags", "autoSetMeta", "showCount", "showIcon", "showText", "size", "opened", "closed", "count", 4, "ngFor", "ngForOf"], [3, "expanded", "moreIcon", "lessIcon", "size", "toggle", 4, "ngIf"], [3, "button", "theme", "url", "title", "description", "image", "tags", "autoSetMeta", "showCount", "showIcon", "showText", "size", "opened", "closed", "count"], [3, "expanded", "moreIcon", "lessIcon", "size", "toggle"]], template: function ShareButtons_Template(rf, ctx) { if (rf & 1) {
                core["ɵɵtemplate"](0, ShareButtons_div_0_Template, 4, 8, "div", 0);
                core["ɵɵpipe"](1, "async");
            } if (rf & 2) {
                core["ɵɵproperty"]("ngIf", core["ɵɵpipeBind1"](1, 1, ctx.state$));
            } }, directives: [common.NgIf, common.NgForOf, button.ShareButton, ExpandButton], pipes: [common.AsyncPipe], styles: ["[_nghost-%COMP%]{display:inherit}"], changeDetection: 0 });
        return ShareButtons;
    }());
    /*@__PURE__*/ (function () { core["ɵsetClassMetadata"](ShareButtons, [{
            type: core.Component,
            args: [{
                    selector: 'share-buttons',
                    templateUrl: './share-buttons.html',
                    styleUrls: ['./share-buttons.scss'],
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                }]
        }], function () { return [{ type: core$1.ShareService }]; }, { theme: [{
                type: core.Input
            }], includedButtons: [{
                type: core.Input,
                args: ['include']
            }], excludedButtons: [{
                type: core.Input,
                args: ['exclude']
            }], shownButtons: [{
                type: core.Input,
                args: ['show']
            }], url: [{
                type: core.Input
            }], title: [{
                type: core.Input
            }], description: [{
                type: core.Input
            }], image: [{
                type: core.Input
            }], tags: [{
                type: core.Input
            }], autoSetMeta: [{
                type: core.Input
            }], showIcon: [{
                type: core.Input
            }], showText: [{
                type: core.Input
            }], showCount: [{
                type: core.Input
            }], size: [{
                type: core.Input
            }], count: [{
                type: core.Output
            }], opened: [{
                type: core.Output
            }], closed: [{
                type: core.Output
            }] }); })();

    var ShareButtonsModule = /** @class */ (function () {
        function ShareButtonsModule() {
        }
        ShareButtonsModule.withConfig = function (config) {
            return {
                ngModule: ShareButtonsModule,
                providers: [{ provide: core$1.SHARE_BUTTONS_CONFIG, useValue: config }]
            };
        };
        ShareButtonsModule.ɵmod = core["ɵɵdefineNgModule"]({ type: ShareButtonsModule });
        ShareButtonsModule.ɵinj = core["ɵɵdefineInjector"]({ factory: function ShareButtonsModule_Factory(t) { return new (t || ShareButtonsModule)(); }, imports: [[
                    button.ShareButtonModule,
                    common.CommonModule
                ],
                button.ShareButtonModule] });
        return ShareButtonsModule;
    }());
    (function () { (typeof ngJitMode === "undefined" || ngJitMode) && core["ɵɵsetNgModuleScope"](ShareButtonsModule, { declarations: [ShareButtons,
            ExpandButton], imports: [button.ShareButtonModule,
            common.CommonModule], exports: [button.ShareButtonModule,
            ShareButtons] }); })();
    /*@__PURE__*/ (function () { core["ɵsetClassMetadata"](ShareButtonsModule, [{
            type: core.NgModule,
            args: [{
                    declarations: [
                        ShareButtons,
                        ExpandButton
                    ],
                    imports: [
                        button.ShareButtonModule,
                        common.CommonModule
                    ],
                    exports: [
                        button.ShareButtonModule,
                        ShareButtons
                    ]
                }]
        }], null, null); })();

    exports.ShareButtons = ShareButtons;
    exports.ShareButtonsModule = ShareButtonsModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-share-buttons.umd.js.map
