(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/platform'), require('@angular/common'), require('@angular/common/http'), require('@angular/platform-browser'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@ngx-share/core', ['exports', '@angular/core', '@angular/cdk/platform', '@angular/common', '@angular/common/http', '@angular/platform-browser', 'rxjs', 'rxjs/operators'], factory) :
    (global = global || self, factory((global['ngx-share'] = global['ngx-share'] || {}, global['ngx-share'].core = {}), global.ng.core, global.ng.cdk.platform, global.ng.common, global.ng.common.http, global.ng.platformBrowser, global.rxjs, global.rxjs.operators));
}(this, (function (exports, core, platform, common, http, platformBrowser, rxjs, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var SHARE_BUTTONS_CONFIG = new core.InjectionToken('shareButtonsConfig');

    var ShareButtonBase = /** @class */ (function () {
        function ShareButtonBase(_props, _url, _http, _platform, _document, _windowSize, 
        // disable button click (used in copy button)
        _disableButtonClick, 
        // Logger function (debug mode)
        _logger) {
            this._props = _props;
            this._url = _url;
            this._http = _http;
            this._platform = _platform;
            this._document = _document;
            this._windowSize = _windowSize;
            this._disableButtonClick = _disableButtonClick;
            this._logger = _logger;
            this._self = this;
            /** If share button supports share count */
            this.supportShareCount = false;
        }
        Object.defineProperty(ShareButtonBase.prototype, "text", {
            /** Share button label */
            get: function () {
                return this._props.text;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButtonBase.prototype, "ariaLabel", {
            /** Share button aria-label attribute */
            get: function () {
                return this._props.ariaLabel;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButtonBase.prototype, "color", {
            /** Share button color */
            get: function () {
                return this._props.color;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButtonBase.prototype, "icon", {
            /** Share button icon (FontAwesome) */
            get: function () {
                return this._props.icon;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButtonBase.prototype, "desktop", {
            get: function () {
                return undefined;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButtonBase.prototype, "android", {
            get: function () {
                return this.desktop;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButtonBase.prototype, "ios", {
            get: function () {
                return this.desktop;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButtonBase.prototype, "sharerUrl", {
            get: function () {
                if (this._platform.IOS)
                    return this.ios;
                if (this._platform.ANDROID)
                    return this.android;
                return this.desktop;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Opens share window
         */
        ShareButtonBase.prototype.click = function (metaTags) {
            return this._open(this._serializeMetaTags(metaTags));
        };
        /** Get share count of a URL */
        ShareButtonBase.prototype.shareCount = function (url) {
            return undefined;
        };
        ShareButtonBase.prototype._serializeMetaTags = function (metaTags) {
            return Object.entries(this._supportedMetaTags)
                .map(function (_a) {
                var _b = __read(_a, 2), key = _b[0], value = _b[1];
                return metaTags[key] ? value + "=" + encodeURIComponent(metaTags[key]) : '';
            })
                .join('&');
        };
        ShareButtonBase.prototype._open = function (serializedMetaTags) {
            var _this = this;
            return new Promise(function (resolve) {
                // Avoid SSR error
                if (_this.sharerUrl && _this._platform.isBrowser) {
                    var finalUrl = _this.sharerUrl + serializedMetaTags;
                    // Debug mode, log sharer link
                    _this._logger(finalUrl);
                    var popUp_1 = _this._document.defaultView.open(finalUrl, 'newwindow', _this._windowSize);
                    // Resolve when share dialog is closed
                    if (popUp_1) {
                        var pollTimer_1 = _this._document.defaultView.setInterval(function () {
                            if (popUp_1.closed) {
                                _this._document.defaultView.clearInterval(pollTimer_1);
                                resolve();
                            }
                        }, 200);
                    }
                }
                else {
                    console.warn(_this.text + " button is not compatible on this Platform");
                }
            });
        };
        return ShareButtonBase;
    }());

    var FacebookButton = /** @class */ (function (_super) {
        __extends(FacebookButton, _super);
        function FacebookButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this.supportShareCount = true;
            _this._supportedMetaTags = {
                url: 'u'
            };
            return _this;
        }
        Object.defineProperty(FacebookButton.prototype, "desktop", {
            get: function () {
                return "https://www.facebook.com/sharer/sharer.php?";
            },
            enumerable: true,
            configurable: true
        });
        FacebookButton.prototype.shareCount = function (url) {
            return this._http.get("https://graph.facebook.com?id=" + url).pipe(operators.map(function (res) { return +res.share.share_count; }));
        };
        return FacebookButton;
    }(ShareButtonBase));

    var TwitterButton = /** @class */ (function (_super) {
        __extends(TwitterButton, _super);
        function TwitterButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                url: 'url',
                description: 'text',
                tags: 'hashtags',
                via: 'via'
            };
            return _this;
        }
        Object.defineProperty(TwitterButton.prototype, "desktop", {
            get: function () {
                return "https://twitter.com/intent/tweet?";
            },
            enumerable: true,
            configurable: true
        });
        return TwitterButton;
    }(ShareButtonBase));

    var LinkedinButton = /** @class */ (function (_super) {
        __extends(LinkedinButton, _super);
        function LinkedinButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                url: 'url',
                title: 'title',
                description: 'summary'
            };
            return _this;
        }
        Object.defineProperty(LinkedinButton.prototype, "desktop", {
            get: function () {
                return "http://www.linkedin.com/shareArticle?";
            },
            enumerable: true,
            configurable: true
        });
        return LinkedinButton;
    }(ShareButtonBase));

    var GooglePlusButton = /** @class */ (function (_super) {
        __extends(GooglePlusButton, _super);
        function GooglePlusButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                url: 'url'
            };
            return _this;
        }
        Object.defineProperty(GooglePlusButton.prototype, "desktop", {
            get: function () {
                return "https://plus.google.com/share?";
            },
            enumerable: true,
            configurable: true
        });
        return GooglePlusButton;
    }(ShareButtonBase));

    var TumblrButton = /** @class */ (function (_super) {
        __extends(TumblrButton, _super);
        function TumblrButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this.supportShareCount = true;
            _this._supportedMetaTags = {
                url: 'canonicalUrl',
                description: 'caption',
                tags: 'tags'
            };
            return _this;
        }
        Object.defineProperty(TumblrButton.prototype, "desktop", {
            get: function () {
                return "http://tumblr.com/widgets/share/tool?";
            },
            enumerable: true,
            configurable: true
        });
        TumblrButton.prototype.shareCount = function (url) {
            return this._http.jsonp("https://api.tumblr.com/v2/share/stats?url=" + url, 'callback').pipe(operators.map(function (res) { return +res.response.note_count; }));
        };
        return TumblrButton;
    }(ShareButtonBase));

    var PinterestButton = /** @class */ (function (_super) {
        __extends(PinterestButton, _super);
        function PinterestButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this.supportShareCount = true;
            _this._supportedMetaTags = {
                url: 'url',
                description: 'description',
                image: 'media'
            };
            return _this;
        }
        Object.defineProperty(PinterestButton.prototype, "desktop", {
            get: function () {
                return "https://pinterest.com/pin/create/button/?";
            },
            enumerable: true,
            configurable: true
        });
        PinterestButton.prototype.click = function (metaTags) {
            // Check if image parameter is defined
            if (metaTags.image) {
                return this._open(this._serializeMetaTags(metaTags));
            }
            console.warn('Pinterest button: image parameter is required!');
        };
        PinterestButton.prototype.shareCount = function (url) {
            return this._http.get("https://api.pinterest.com/v1/urls/count.json?url=" + url, { responseType: 'text' }).pipe(operators.map(function (text) { return JSON.parse(text.replace(/^receiveCount\((.*)\)/, '$1')); }), operators.map(function (res) { return +res.count; }));
        };
        return PinterestButton;
    }(ShareButtonBase));

    var RedditButton = /** @class */ (function (_super) {
        __extends(RedditButton, _super);
        function RedditButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                url: 'url',
                title: 'title'
            };
            return _this;
        }
        Object.defineProperty(RedditButton.prototype, "desktop", {
            get: function () {
                return "http://www.reddit.com/submit?";
            },
            enumerable: true,
            configurable: true
        });
        return RedditButton;
    }(ShareButtonBase));

    var VkButton = /** @class */ (function (_super) {
        __extends(VkButton, _super);
        function VkButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                url: 'url'
            };
            return _this;
        }
        Object.defineProperty(VkButton.prototype, "desktop", {
            get: function () {
                return "http://vk.com/share.php?";
            },
            enumerable: true,
            configurable: true
        });
        return VkButton;
    }(ShareButtonBase));

    var TelegramButton = /** @class */ (function (_super) {
        __extends(TelegramButton, _super);
        function TelegramButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                url: 'url',
                description: 'text'
            };
            return _this;
        }
        Object.defineProperty(TelegramButton.prototype, "desktop", {
            get: function () {
                return 'https://t.me/share/url?';
            },
            enumerable: true,
            configurable: true
        });
        return TelegramButton;
    }(ShareButtonBase));

    var MessengerButton = /** @class */ (function (_super) {
        __extends(MessengerButton, _super);
        function MessengerButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                url: 'link'
            };
            return _this;
        }
        Object.defineProperty(MessengerButton.prototype, "android", {
            get: function () {
                return 'fb-messenger://share/?';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MessengerButton.prototype, "ios", {
            get: function () {
                return 'fb-messenger://share/?';
            },
            enumerable: true,
            configurable: true
        });
        return MessengerButton;
    }(ShareButtonBase));

    var WhatsappButton = /** @class */ (function (_super) {
        __extends(WhatsappButton, _super);
        function WhatsappButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                description: 'text'
            };
            return _this;
        }
        Object.defineProperty(WhatsappButton.prototype, "desktop", {
            get: function () {
                return "https://wa.me/?";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WhatsappButton.prototype, "android", {
            get: function () {
                return "whatsapp://send?";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WhatsappButton.prototype, "ios", {
            get: function () {
                return "https://api.whatsapp.com/send?";
            },
            enumerable: true,
            configurable: true
        });
        WhatsappButton.prototype.click = function (metaTags) {
            // Add the URL to message body
            metaTags.description = metaTags.description ? metaTags.description + "\r\n" + this._url() : this._url();
            var serializedMetaTags = this._serializeMetaTags(metaTags);
            return this._open(serializedMetaTags);
        };
        return WhatsappButton;
    }(ShareButtonBase));

    var XingButton = /** @class */ (function (_super) {
        __extends(XingButton, _super);
        function XingButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                url: 'url'
            };
            return _this;
        }
        Object.defineProperty(XingButton.prototype, "desktop", {
            get: function () {
                return "https://www.xing.com/app/user?op=share&";
            },
            enumerable: true,
            configurable: true
        });
        return XingButton;
    }(ShareButtonBase));

    var SmsButton = /** @class */ (function (_super) {
        __extends(SmsButton, _super);
        function SmsButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                description: 'body'
            };
            return _this;
        }
        Object.defineProperty(SmsButton.prototype, "desktop", {
            get: function () {
                return "sms:?";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SmsButton.prototype, "android", {
            get: function () {
                return "sms:?";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SmsButton.prototype, "ios", {
            get: function () {
                return 'sms:&';
            },
            enumerable: true,
            configurable: true
        });
        SmsButton.prototype.click = function (metaTags) {
            // Add the URL to message body
            metaTags.description = metaTags.description ? metaTags.description + "\r\n" + this._url() : this._url();
            var serializedMetaTags = this._serializeMetaTags(metaTags);
            return this._open(serializedMetaTags);
        };
        return SmsButton;
    }(ShareButtonBase));

    var EmailButton = /** @class */ (function (_super) {
        __extends(EmailButton, _super);
        function EmailButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                title: 'subject',
                description: 'body'
            };
            return _this;
        }
        Object.defineProperty(EmailButton.prototype, "desktop", {
            get: function () {
                return "mailto:?";
            },
            enumerable: true,
            configurable: true
        });
        EmailButton.prototype.click = function (metaTags) {
            // Add URL to message body
            metaTags.description = metaTags.description ? metaTags.description + "\r\n" + this._url() : this._url();
            var serializedMetaTags = this._serializeMetaTags(metaTags);
            return this._open(serializedMetaTags);
        };
        return EmailButton;
    }(ShareButtonBase));

    var PrintButton = /** @class */ (function (_super) {
        __extends(PrintButton, _super);
        function PrintButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            return _this;
        }
        PrintButton.prototype.click = function () {
            var _this = this;
            return new Promise(function (resolve) {
                _this._document.defaultView.print();
                resolve();
            });
        };
        return PrintButton;
    }(ShareButtonBase));

    var CopyButton = /** @class */ (function (_super) {
        __extends(CopyButton, _super);
        function CopyButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            return _this;
        }
        Object.defineProperty(CopyButton.prototype, "text", {
            get: function () {
                return this._disable ? this._props.extra.successLabel : this._props.text;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CopyButton.prototype, "icon", {
            get: function () {
                return this._disable ? this._props.extra.successIcon : this._props.icon;
            },
            enumerable: true,
            configurable: true
        });
        CopyButton.prototype._disableButton = function () {
            // Disable pointer for tiny delay
            this._disable = true;
            this._disableButtonClick(true);
        };
        CopyButton.prototype._resetButton = function () {
            this._disable = false;
            this._disableButtonClick(false);
        };
        CopyButton.prototype.click = function () {
            var _this = this;
            return new Promise(function (resolve) {
                try {
                    var textArea = _this._document.createElement('textarea');
                    textArea.value = decodeURIComponent(_this._url());
                    _this._document.body.appendChild(textArea);
                    // highlight TextArea to copy the sharing link
                    if (_this._platform.IOS) {
                        var range = _this._document.createRange();
                        range.selectNodeContents(textArea);
                        var selection = _this._document.defaultView.getSelection();
                        selection.removeAllRanges();
                        selection.addRange(range);
                        textArea.readOnly = true;
                        textArea.setSelectionRange(0, 999999);
                    }
                    else {
                        textArea.select();
                    }
                    _this._document.execCommand('copy');
                    _this._document.body.removeChild(textArea);
                    _this._disableButton();
                }
                catch (e) {
                    console.warn('Copy link failed!', e.message);
                }
                finally {
                    setTimeout(function () { return _this._resetButton(); }, 2000);
                    resolve();
                }
            });
        };
        return CopyButton;
    }(ShareButtonBase));

    var MixButton = /** @class */ (function (_super) {
        __extends(MixButton, _super);
        function MixButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                url: 'url'
            };
            return _this;
        }
        Object.defineProperty(MixButton.prototype, "desktop", {
            get: function () {
                return "https://mix.com/add?";
            },
            enumerable: true,
            configurable: true
        });
        return MixButton;
    }(ShareButtonBase));

    var LineButton = /** @class */ (function (_super) {
        __extends(LineButton, _super);
        function LineButton(_props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) {
            var _this = _super.call(this, _props, _url, _http, _platform, _document, _windowSize, _disableButtonClick, _logger) || this;
            _this._props = _props;
            _this._url = _url;
            _this._http = _http;
            _this._platform = _platform;
            _this._document = _document;
            _this._windowSize = _windowSize;
            _this._disableButtonClick = _disableButtonClick;
            _this._logger = _logger;
            _this._supportedMetaTags = {
                url: 'url'
            };
            return _this;
        }
        Object.defineProperty(LineButton.prototype, "desktop", {
            get: function () {
                return "https://social-plugins.line.me/lineit/share?";
            },
            enumerable: true,
            configurable: true
        });
        return LineButton;
    }(ShareButtonBase));

    /**
     * Default share buttons properties
     */
    var SHARE_BUTTONS = {
        facebook: {
            create: function (a, b, c, d, e, f, g, h) { return new FacebookButton(a, b, c, d, e, f, g, h); },
            text: 'Facebook',
            icon: ['fab', 'facebook-f'],
            color: '#4267B2',
            ariaLabel: 'Share on Facebook'
        },
        twitter: {
            create: function (a, b, c, d, e, f, g, h) { return new TwitterButton(a, b, c, d, e, f, g, h); },
            text: 'Twitter',
            icon: ['fab', 'twitter'],
            color: '#00acee',
            ariaLabel: 'Share on Twitter'
        },
        linkedin: {
            create: function (a, b, c, d, e, f, g, h) { return new LinkedinButton(a, b, c, d, e, f, g, h); },
            text: 'LinkedIn',
            icon: ['fab', 'linkedin-in'],
            color: '#006fa6',
            ariaLabel: 'Share on LinkedIn'
        },
        google: {
            create: function (a, b, c, d, e, f, g, h) { return new GooglePlusButton(a, b, c, d, e, f, g, h); },
            text: 'Google+',
            icon: ['fab', 'google-plus-g'],
            color: '#DB4437',
            ariaLabel: 'Share on Google plus'
        },
        pinterest: {
            create: function (a, b, c, d, e, f, g, h) { return new PinterestButton(a, b, c, d, e, f, g, h); },
            text: 'Pinterest',
            icon: ['fab', 'pinterest-p'],
            color: '#BD091D',
            ariaLabel: 'Share on Pinterest'
        },
        reddit: {
            create: function (a, b, c, d, e, f, g, h) { return new RedditButton(a, b, c, d, e, f, g, h); },
            text: 'Reddit',
            icon: ['fab', 'reddit-alien'],
            color: '#FF4006',
            ariaLabel: 'Share on Reddit'
        },
        tumblr: {
            create: function (a, b, c, d, e, f, g, h) { return new TumblrButton(a, b, c, d, e, f, g, h); },
            text: 'Tumblr',
            icon: ['fab', 'tumblr'],
            color: '#36465D',
            ariaLabel: 'Share on Tumblr'
        },
        mix: {
            create: function (a, b, c, d, e, f, g, h) { return new MixButton(a, b, c, d, e, f, g, h); },
            text: 'Mix',
            icon: ['fab', 'mix'],
            color: '#ff8226',
            ariaLabel: 'Share on Mix'
        },
        vk: {
            create: function (a, b, c, d, e, f, g, h) { return new VkButton(a, b, c, d, e, f, g, h); },
            text: 'VKontakte',
            icon: ['fab', 'vk'],
            color: '#4C75A3',
            ariaLabel: 'Share on VKontakte'
        },
        telegram: {
            create: function (a, b, c, d, e, f, g, h) { return new TelegramButton(a, b, c, d, e, f, g, h); },
            text: 'Telegram',
            icon: ['fab', 'telegram-plane'],
            color: '#0088cc',
            ariaLabel: 'Share on Telegram'
        },
        messenger: {
            create: function (a, b, c, d, e, f, g, h) { return new MessengerButton(a, b, c, d, e, f, g, h); },
            text: 'Messenger',
            icon: ['fab', 'facebook-messenger'],
            color: '#0080FF',
            ariaLabel: 'Share on Messenger'
        },
        whatsapp: {
            create: function (a, b, c, d, e, f, g, h) { return new WhatsappButton(a, b, c, d, e, f, g, h); },
            text: 'WhatsApp',
            icon: ['fab', 'whatsapp'],
            color: '#25D366',
            ariaLabel: 'Share on WhatsApp'
        },
        xing: {
            create: function (a, b, c, d, e, f, g, h) { return new XingButton(a, b, c, d, e, f, g, h); },
            text: 'Xing',
            icon: ['fab', 'xing'],
            color: '#006567',
            ariaLabel: 'Share on Xing'
        },
        line: {
            create: function (a, b, c, d, e, f, g, h) { return new LineButton(a, b, c, d, e, f, g, h); },
            text: 'Line',
            icon: ['fab', 'line'],
            color: '#00b900',
            ariaLabel: 'Share on Line'
        },
        sms: {
            create: function (a, b, c, d, e, f, g, h) { return new SmsButton(a, b, c, d, e, f, g, h); },
            text: 'SMS',
            icon: 'comment-alt',
            color: '#20c16c',
            ariaLabel: 'Share link via SMS'
        },
        email: {
            create: function (a, b, c, d, e, f, g, h) { return new EmailButton(a, b, c, d, e, f, g, h); },
            text: 'Email',
            icon: 'envelope',
            color: '#FF961C',
            ariaLabel: 'Share link via email'
        },
        print: {
            create: function (a, b, c, d, e, f, g, h) { return new PrintButton(a, b, c, d, e, f, g, h); },
            text: 'Print',
            icon: 'print',
            color: '#765AA2',
            ariaLabel: 'Print page'
        },
        copy: {
            create: function (a, b, c, d, e, f, g, h) { return new CopyButton(a, b, c, d, e, f, g, h); },
            text: 'Copy link',
            icon: 'link',
            color: '#607D8B',
            ariaLabel: 'Copy link',
            extra: {
                successLabel: 'Copied',
                successIcon: 'check'
            }
        },
    };

    /** Simple object check.*/
    function isObject(item) {
        return (item && typeof item === 'object' && !Array.isArray(item));
    }
    /** Deep merge two objects.*/
    function mergeDeep(target) {
        var _a, _b;
        var sources = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            sources[_i - 1] = arguments[_i];
        }
        if (!sources.length) {
            return target;
        }
        var source = sources.shift();
        if (isObject(target) && isObject(source)) {
            for (var key in source) {
                if (isObject(source[key])) {
                    if (!target[key]) {
                        Object.assign(target, (_a = {}, _a[key] = {}, _a));
                    }
                    mergeDeep(target[key], source[key]);
                }
                else {
                    Object.assign(target, (_b = {}, _b[key] = source[key], _b));
                }
            }
        }
        return mergeDeep.apply(void 0, __spread([target], sources));
    }
    /** Returns a readable number from share count */
    function shareCountFormatter(num, digits) {
        var si = [
            { value: 1E9, symbol: 'B' },
            { value: 1E6, symbol: 'M' },
            { value: 1E3, symbol: 'K' }
        ], rx = /\.0+$|(\.[0-9]*[1-9])0+$/;
        for (var i = 0; i < si.length; i++) {
            if (num >= si[i].value) {
                return (num / si[i].value).toFixed(digits).replace(rx, '$1') + si[i].symbol;
            }
        }
        return num.toFixed(digits).replace(rx, '$1');
    }
    /** Returns a valid URL or falls back to current URL */
    function getValidUrl(url, fallbackUrl) {
        if (url) {
            var r = /(http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
            if (r.test(url))
                return url;
            console.warn("[ShareButtons]: Sharing link '" + url + "' is invalid!");
        }
        return fallbackUrl;
    }

    var ShareService = /** @class */ (function () {
        function ShareService(config) {
            /** Global config that applies on all share buttons in the app */
            this.config = {
                prop: SHARE_BUTTONS,
                theme: 'default',
                include: [],
                exclude: [],
                size: 0,
                autoSetMeta: true,
                windowWidth: 800,
                windowHeight: 500,
                moreButtonIcon: 'ellipsis-h',
                lessButtonIcon: 'minus'
            };
            /** Stream that emits when config changes */
            this.config$ = new rxjs.BehaviorSubject(this.config);
            if (config) {
                this.setConfig(config);
            }
        }
        Object.defineProperty(ShareService.prototype, "prop", {
            /**
             * Share buttons properties, used to get the text, color and icon of each button.
             */
            get: function () {
                return this.config.prop;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareService.prototype, "windowSize", {
            get: function () {
                return "width=" + this.config.windowWidth + ", height=" + this.config.windowHeight;
            },
            enumerable: true,
            configurable: true
        });
        ShareService.prototype.setConfig = function (config) {
            this.config = mergeDeep(this.config, config);
            this.config$.next(this.config);
        };
        ShareService.ɵfac = function ShareService_Factory(t) { return new (t || ShareService)(core["ɵɵinject"](SHARE_BUTTONS_CONFIG, 8)); };
        ShareService.ɵprov = core["ɵɵdefineInjectable"]({ token: ShareService, factory: ShareService.ɵfac, providedIn: 'root' });
        return ShareService;
    }());
    /*@__PURE__*/ (function () { core["ɵsetClassMetadata"](ShareService, [{
            type: core.Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return [{ type: undefined, decorators: [{
                    type: core.Optional
                }, {
                    type: core.Inject,
                    args: [SHARE_BUTTONS_CONFIG]
                }] }]; }, null); })();

    var ShareDirective = /** @class */ (function () {
        function ShareDirective(_meta, _el, _http, _platform, _renderer, _cd, _share, _document) {
            this._meta = _meta;
            this._el = _el;
            this._http = _http;
            this._platform = _platform;
            this._renderer = _renderer;
            this._cd = _cd;
            this._share = _share;
            this._document = _document;
            /** Share window closed event subscription */
            this._shareWindowClosed = rxjs.Subscription.EMPTY;
            /** Get share count */
            this.getCount = false;
            /** Set meta tags from document head, useful when SEO is supported */
            this.autoSetMeta = this._share.config.autoSetMeta;
            /** Sharing link */
            this.url = this._share.config.url;
            /** Sets the title parameter */
            this.title = this._share.config.title;
            /** Sets the description parameter */
            this.description = this._share.config.description;
            /** Sets the image parameter for sharing on Pinterest */
            this.image = this._share.config.image;
            /** Sets the tags parameter for sharing on Twitter and Tumblr */
            this.tags = this._share.config.tags;
            /** Stream that emits when share count is fetched */
            this.count = new core.EventEmitter();
            /** Stream that emits when share dialog is opened */
            this.opened = new core.EventEmitter();
            /** Stream that emits when share dialog is closed */
            this.closed = new core.EventEmitter();
        }
        /** Share the link */
        ShareDirective.prototype.share = function () {
            var _this = this;
            var metaTags = this.autoSetMeta ? {
                url: this.url,
                title: this.title || this._getMetaTagContent('og:title'),
                description: this.description || this._getMetaTagContent('og:description'),
                image: this.image || this._getMetaTagContent('og:image'),
                via: this._share.config.twitterAccount,
                tags: this.tags,
            } : {
                url: this.url,
                title: this.title,
                description: this.description,
                image: this.image,
                tags: this.tags,
                via: this._share.config.twitterAccount,
            };
            // Emit when share dialog is opened
            this.opened.emit(this.shareButtonName);
            // Share the link
            this.shareButton.click(metaTags).then(function () {
                // Emit when share dialog is closed
                return _this.closed.emit(_this.shareButtonName);
            });
        };
        ShareDirective.prototype.ngOnChanges = function (changes) {
            var _this = this;
            // Avoid SSR error
            if (this._platform.isBrowser) {
                if (this._shareButtonChanged(changes['shareButtonName'])) {
                    this._createShareButton();
                }
                if (this._urlChanged(changes['url'])) {
                    this.url = getValidUrl(this.autoSetMeta
                        ? this.url || this._getMetaTagContent('og:url')
                        : this.url, this._document.defaultView.location.href);
                    if (this.getCount && this.shareButton.supportShareCount) {
                        this.shareButton.shareCount(this.url).subscribe(function (count) { return _this.count.emit(count); });
                    }
                }
            }
        };
        ShareDirective.prototype.ngOnDestroy = function () {
            this._shareWindowClosed.unsubscribe();
        };
        ShareDirective.prototype._createShareButton = function () {
            var _this = this;
            var shareButtonFactory = this._share.config.prop[this.shareButtonName];
            var button = shareButtonFactory.create(shareButtonFactory, 
            // Pass the url property as a function, so the button class always gets the recent url value.
            function () { return _this.url; }, this._http, this._platform, this._document, this._share.windowSize, 
            // This function is meant for the copy button
            function (disabled) {
                _this.pointerEvents = disabled ? 'none' : 'auto';
                _this._cd.markForCheck();
            }, 
            // Logger used for debugging
            function (text) { return _this._share.config.debug ? console.log(text) : null; });
            if (button) {
                // Set share button properties
                this.shareButton = button;
                // Remove previous button class
                this._renderer.removeClass(this._el.nativeElement, "sb-" + this._buttonClass);
                // Add new button class
                this._renderer.addClass(this._el.nativeElement, "sb-" + this.shareButtonName);
                // Set button css color variable
                this._el.nativeElement.style.setProperty('--button-color', this.shareButton.color);
                // Keep a copy of the class for future replacement
                this._buttonClass = this.shareButtonName;
                // Set aria-label attribute
                this._renderer.setAttribute(this._el.nativeElement, 'aria-label', button.ariaLabel);
            }
            else {
                console.error("[ShareButtons]: The share button '" + this.shareButtonName + "' does not exist!");
            }
        };
        /** Get meta tag content */
        ShareDirective.prototype._getMetaTagContent = function (key) {
            var metaUsingProperty = this._meta.getTag("property=\"" + key + "\"");
            if (metaUsingProperty)
                return metaUsingProperty.getAttribute('content');
            var metaUsingName = this._meta.getTag("name=\"" + key + "\"");
            if (metaUsingName)
                return metaUsingName.getAttribute('content');
        };
        ShareDirective.prototype._shareButtonChanged = function (change) {
            return change && (change.firstChange || change.previousValue !== change.currentValue);
        };
        ShareDirective.prototype._urlChanged = function (change) {
            return !this.url || (change && change.previousValue !== change.currentValue);
        };
        ShareDirective.ɵfac = function ShareDirective_Factory(t) { return new (t || ShareDirective)(core["ɵɵdirectiveInject"](platformBrowser.Meta), core["ɵɵdirectiveInject"](core.ElementRef), core["ɵɵdirectiveInject"](http.HttpClient), core["ɵɵdirectiveInject"](platform.Platform), core["ɵɵdirectiveInject"](core.Renderer2), core["ɵɵdirectiveInject"](core.ChangeDetectorRef), core["ɵɵdirectiveInject"](ShareService), core["ɵɵdirectiveInject"](common.DOCUMENT)); };
        ShareDirective.ɵdir = core["ɵɵdefineDirective"]({ type: ShareDirective, selectors: [["", "shareButton", ""], ["", "share-button", ""]], hostVars: 2, hostBindings: function ShareDirective_HostBindings(rf, ctx) { if (rf & 1) {
                core["ɵɵlistener"]("click", function ShareDirective_click_HostBindingHandler() { return ctx.share(); });
            } if (rf & 2) {
                core["ɵɵstyleProp"]("pointer-events", ctx.pointerEvents);
            } }, inputs: { shareButtonName: ["shareButton", "shareButtonName"], getCount: "getCount", autoSetMeta: "autoSetMeta", url: "url", title: "title", description: "description", image: "image", tags: "tags" }, outputs: { count: "count", opened: "opened", closed: "closed" }, features: [core["ɵɵNgOnChangesFeature"]] });
        return ShareDirective;
    }());
    /*@__PURE__*/ (function () { core["ɵsetClassMetadata"](ShareDirective, [{
            type: core.Directive,
            args: [{
                    selector: '[shareButton], [share-button]'
                }]
        }], function () { return [{ type: platformBrowser.Meta }, { type: core.ElementRef }, { type: http.HttpClient }, { type: platform.Platform }, { type: core.Renderer2 }, { type: core.ChangeDetectorRef }, { type: ShareService }, { type: undefined, decorators: [{
                    type: core.Inject,
                    args: [common.DOCUMENT]
                }] }]; }, { shareButtonName: [{
                type: core.Input,
                args: ['shareButton']
            }], getCount: [{
                type: core.Input
            }], autoSetMeta: [{
                type: core.Input
            }], url: [{
                type: core.Input
            }], title: [{
                type: core.Input
            }], description: [{
                type: core.Input
            }], image: [{
                type: core.Input
            }], tags: [{
                type: core.Input
            }], count: [{
                type: core.Output
            }], opened: [{
                type: core.Output
            }], closed: [{
                type: core.Output
            }], pointerEvents: [{
                type: core.HostBinding,
                args: ['style.pointerEvents']
            }], share: [{
                type: core.HostListener,
                args: ['click']
            }] }); })();

    var ShareCountPipe = /** @class */ (function () {
        function ShareCountPipe() {
        }
        ShareCountPipe.prototype.transform = function (num, digits) {
            return shareCountFormatter(num, digits);
        };
        ShareCountPipe.ɵfac = function ShareCountPipe_Factory(t) { return new (t || ShareCountPipe)(); };
        ShareCountPipe.ɵpipe = core["ɵɵdefinePipe"]({ name: "shareCount", type: ShareCountPipe, pure: true });
        return ShareCountPipe;
    }());
    /*@__PURE__*/ (function () { core["ɵsetClassMetadata"](ShareCountPipe, [{
            type: core.Pipe,
            args: [{
                    name: 'shareCount'
                }]
        }], null, null); })();

    var ShareModule = /** @class */ (function () {
        function ShareModule() {
        }
        ShareModule.withConfig = function (config) {
            return {
                ngModule: ShareModule,
                providers: [
                    { provide: SHARE_BUTTONS_CONFIG, useValue: config }
                ]
            };
        };
        ShareModule.ɵmod = core["ɵɵdefineNgModule"]({ type: ShareModule });
        ShareModule.ɵinj = core["ɵɵdefineInjector"]({ factory: function ShareModule_Factory(t) { return new (t || ShareModule)(); }, imports: [[
                    platform.PlatformModule
                ]] });
        return ShareModule;
    }());
    (function () { (typeof ngJitMode === "undefined" || ngJitMode) && core["ɵɵsetNgModuleScope"](ShareModule, { declarations: [ShareDirective,
            ShareCountPipe], imports: [platform.PlatformModule], exports: [ShareDirective,
            ShareCountPipe] }); })();
    /*@__PURE__*/ (function () { core["ɵsetClassMetadata"](ShareModule, [{
            type: core.NgModule,
            args: [{
                    imports: [
                        platform.PlatformModule
                    ],
                    declarations: [
                        ShareDirective,
                        ShareCountPipe
                    ],
                    exports: [
                        ShareDirective,
                        ShareCountPipe
                    ]
                }]
        }], null, null); })();

    exports.SHARE_BUTTONS = SHARE_BUTTONS;
    exports.SHARE_BUTTONS_CONFIG = SHARE_BUTTONS_CONFIG;
    exports.ShareCountPipe = ShareCountPipe;
    exports.ShareDirective = ShareDirective;
    exports.ShareModule = ShareModule;
    exports.ShareService = ShareService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-share-core.umd.js.map
