(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@ngx-share/core'), require('@fortawesome/angular-fontawesome')) :
    typeof define === 'function' && define.amd ? define('@ngx-share/button', ['exports', '@angular/core', '@angular/common', '@ngx-share/core', '@fortawesome/angular-fontawesome'], factory) :
    (global = global || self, factory((global['ngx-share'] = global['ngx-share'] || {}, global['ngx-share'].button = {}), global.ng.core, global.ng.common, global.core$1, global.angularFontawesome));
}(this, (function (exports, core, common, core$1, angularFontawesome) { 'use strict';

    function ShareButton_div_3_Template(rf, ctx) { if (rf & 1) {
        core["ɵɵelementStart"](0, "div", 6);
        core["ɵɵelement"](1, "fa-icon", 7);
        core["ɵɵelementEnd"]();
    } if (rf & 2) {
        var ctx_r3 = core["ɵɵnextContext"]();
        core["ɵɵadvance"](1);
        core["ɵɵproperty"]("icon", ctx_r3.icon || ctx_r3.ref.shareButton.icon)("fixedWidth", true);
    } }
    function ShareButton_div_4_Template(rf, ctx) { if (rf & 1) {
        core["ɵɵelementStart"](0, "div", 8);
        core["ɵɵtext"](1);
        core["ɵɵelementEnd"]();
    } if (rf & 2) {
        var ctx_r4 = core["ɵɵnextContext"]();
        core["ɵɵadvance"](1);
        core["ɵɵtextInterpolate1"](" ", ctx_r4.text || ctx_r4.ref.shareButton.text, " ");
    } }
    function ShareButton_div_5_Template(rf, ctx) { if (rf & 1) {
        core["ɵɵelementStart"](0, "div", 9);
        core["ɵɵelementStart"](1, "span");
        core["ɵɵtext"](2);
        core["ɵɵpipe"](3, "shareCount");
        core["ɵɵelementEnd"]();
        core["ɵɵelementEnd"]();
    } if (rf & 2) {
        var ctx_r5 = core["ɵɵnextContext"]();
        core["ɵɵadvance"](2);
        core["ɵɵtextInterpolate"](core["ɵɵpipeBind1"](3, 1, ctx_r5.shareCount));
    } }
    var ShareButton = /** @class */ (function () {
        function ShareButton(_share) {
            this._share = _share;
            /** Show button icon */
            this.showIcon = true;
            /** Show button text */
            this.showText = false;
            /** Show sharing count */
            this.showCount = false;
            /** Button size */
            this.size = this._share.config.size;
            /** Button theme */
            this.theme = this._share.config.theme;
            /** Stream that emits when share count is fetched */
            this.count = new core.EventEmitter();
            /** Stream that emits when share dialog is opened */
            this.opened = new core.EventEmitter();
            /** Stream that emits when share dialog is closed */
            this.closed = new core.EventEmitter();
        }
        Object.defineProperty(ShareButton.prototype, "createButton", {
            set: function (button) {
                this.shareCount = 0;
                this.button = button;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButton.prototype, "setUrl", {
            /** Set the sharing link */
            set: function (url) {
                this.shareCount = 0;
                this.url = url;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShareButton.prototype, "buttonClass", {
            /** Set theme as button class */
            get: function () {
                return "sb-button sb-" + this.theme;
            },
            enumerable: true,
            configurable: true
        });
        ShareButton.prototype.onCount = function (count) {
            this.shareCount = count;
            this.count.emit(count);
        };
        ShareButton.ɵfac = function ShareButton_Factory(t) { return new (t || ShareButton)(core["ɵɵdirectiveInject"](core$1.ShareService)); };
        ShareButton.ɵcmp = core["ɵɵdefineComponent"]({ type: ShareButton, selectors: [["share-button"]], viewQuery: function ShareButton_Query(rf, ctx) { if (rf & 1) {
                core["ɵɵstaticViewQuery"](core$1.ShareDirective, true);
            } if (rf & 2) {
                var _t;
                core["ɵɵqueryRefresh"](_t = core["ɵɵloadQuery"]()) && (ctx.ref = _t.first);
            } }, hostVars: 2, hostBindings: function ShareButton_HostBindings(rf, ctx) { if (rf & 2) {
                core["ɵɵclassMap"](ctx.buttonClass);
            } }, inputs: { createButton: ["button", "createButton"], setUrl: ["url", "setUrl"], title: "title", description: "description", image: "image", tags: "tags", autoSetMeta: "autoSetMeta", showIcon: "showIcon", showText: "showText", showCount: "showCount", text: "text", icon: "icon", size: "size", theme: "theme" }, outputs: { count: "count", opened: "opened", closed: "closed" }, decls: 6, vars: 19, consts: [[1, "sb-wrapper", 3, "shareButton", "url", "image", "title", "description", "tags", "autoSetMeta", "getCount", "count", "opened", "closed"], [1, "sb-inner"], [1, "sb-content"], ["class", "sb-icon", 4, "ngIf"], ["class", "sb-text", 4, "ngIf"], ["class", "sb-count", 4, "ngIf"], [1, "sb-icon"], [3, "icon", "fixedWidth"], [1, "sb-text"], [1, "sb-count"]], template: function ShareButton_Template(rf, ctx) { if (rf & 1) {
                core["ɵɵelementStart"](0, "button", 0);
                core["ɵɵlistener"]("count", function ShareButton_Template_button_count_0_listener($event) { return ctx.onCount($event); })("opened", function ShareButton_Template_button_opened_0_listener($event) { return ctx.opened.emit($event); })("closed", function ShareButton_Template_button_closed_0_listener($event) { return ctx.closed.emit($event); });
                core["ɵɵelementStart"](1, "div", 1);
                core["ɵɵelementStart"](2, "div", 2);
                core["ɵɵtemplate"](3, ShareButton_div_3_Template, 2, 2, "div", 3);
                core["ɵɵtemplate"](4, ShareButton_div_4_Template, 2, 1, "div", 4);
                core["ɵɵelementEnd"]();
                core["ɵɵtemplate"](5, ShareButton_div_5_Template, 4, 3, "div", 5);
                core["ɵɵelementEnd"]();
                core["ɵɵelementEnd"]();
            } if (rf & 2) {
                core["ɵɵstyleProp"]("font-size", (1 + ctx.size / 20) * 14, "px");
                core["ɵɵclassProp"]("sb-show-icon", ctx.showIcon)("sb-show-text", ctx.showText)("sb-show-count", ctx.showCount && ctx.shareCount);
                core["ɵɵproperty"]("shareButton", ctx.button)("url", ctx.url)("image", ctx.image)("title", ctx.title)("description", ctx.description)("tags", ctx.tags)("autoSetMeta", ctx.autoSetMeta)("getCount", ctx.showCount);
                core["ɵɵadvance"](3);
                core["ɵɵproperty"]("ngIf", ctx.showIcon && ctx.ref.shareButton);
                core["ɵɵadvance"](1);
                core["ɵɵproperty"]("ngIf", ctx.showText && ctx.ref.shareButton);
                core["ɵɵadvance"](1);
                core["ɵɵproperty"]("ngIf", ctx.showCount && ctx.shareCount);
            } }, directives: [core$1.ShareDirective, common.NgIf, angularFontawesome.FaIconComponent], pipes: [core$1.ShareCountPipe], styles: [".sb-button,   .sb-group{display:inline-flex;align-items:flex-start}  .sb-group{flex-wrap:wrap}  .sb-button{margin:.3125em}  .sb-wrapper{font-size:inherit;cursor:pointer;position:relative;outline:0;min-width:4.125em;height:2.5em;border:none;border-radius:1px;padding:0;line-height:2.571em;background-color:transparent}  .sb-wrapper .sb-count,   .sb-wrapper .sb-icon,   .sb-wrapper .sb-text{display:flex;align-items:center;justify-content:center;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}  .sb-wrapper .sb-inner{display:flex;flex:1;width:100%;height:100%}  .sb-wrapper .sb-content{display:flex;height:100%;width:100%}  .sb-wrapper .sb-text{padding:0 .7em;flex:1;height:100%;white-space:nowrap}  .sb-wrapper .sb-icon{text-align:center;width:100%;height:100%;font-size:1.2em;min-width:2em}  .sb-wrapper .sb-count{font-size:.9em;padding:0 .7em}  .sb-wrapper .sb-count,   .sb-wrapper .sb-text{font-weight:700}  .sb-show-text .sb-icon{width:2em}  .sb-show-count{min-width:5.333em}"], changeDetection: 0 });
        return ShareButton;
    }());
    /*@__PURE__*/ (function () { core["ɵsetClassMetadata"](ShareButton, [{
            type: core.Component,
            args: [{
                    selector: "share-button",
                    templateUrl: "./share-button.html",
                    styleUrls: ["./share-button.scss"],
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                }]
        }], function () { return [{ type: core$1.ShareService }]; }, { createButton: [{
                type: core.Input,
                args: ["button"]
            }], setUrl: [{
                type: core.Input,
                args: ["url"]
            }], title: [{
                type: core.Input
            }], description: [{
                type: core.Input
            }], image: [{
                type: core.Input
            }], tags: [{
                type: core.Input
            }], autoSetMeta: [{
                type: core.Input
            }], showIcon: [{
                type: core.Input
            }], showText: [{
                type: core.Input
            }], showCount: [{
                type: core.Input
            }], text: [{
                type: core.Input
            }], icon: [{
                type: core.Input
            }], size: [{
                type: core.Input
            }], theme: [{
                type: core.Input
            }], count: [{
                type: core.Output
            }], opened: [{
                type: core.Output
            }], closed: [{
                type: core.Output
            }], buttonClass: [{
                type: core.HostBinding,
                args: ["class"]
            }], ref: [{
                type: core.ViewChild,
                args: [core$1.ShareDirective, { static: true }]
            }] }); })();

    var ShareButtonModule = /** @class */ (function () {
        function ShareButtonModule() {
        }
        ShareButtonModule.withConfig = function (config) {
            return {
                ngModule: ShareButtonModule,
                providers: [{ provide: core$1.SHARE_BUTTONS_CONFIG, useValue: config }]
            };
        };
        ShareButtonModule.ɵmod = core["ɵɵdefineNgModule"]({ type: ShareButtonModule });
        ShareButtonModule.ɵinj = core["ɵɵdefineInjector"]({ factory: function ShareButtonModule_Factory(t) { return new (t || ShareButtonModule)(); }, imports: [[
                    core$1.ShareModule,
                    angularFontawesome.FontAwesomeModule,
                    common.CommonModule
                ],
                core$1.ShareModule,
                angularFontawesome.FontAwesomeModule] });
        return ShareButtonModule;
    }());
    (function () { (typeof ngJitMode === "undefined" || ngJitMode) && core["ɵɵsetNgModuleScope"](ShareButtonModule, { declarations: [ShareButton], imports: [core$1.ShareModule,
            angularFontawesome.FontAwesomeModule,
            common.CommonModule], exports: [core$1.ShareModule,
            angularFontawesome.FontAwesomeModule,
            ShareButton] }); })();
    /*@__PURE__*/ (function () { core["ɵsetClassMetadata"](ShareButtonModule, [{
            type: core.NgModule,
            args: [{
                    declarations: [
                        ShareButton
                    ],
                    imports: [
                        core$1.ShareModule,
                        angularFontawesome.FontAwesomeModule,
                        common.CommonModule
                    ],
                    exports: [
                        core$1.ShareModule,
                        angularFontawesome.FontAwesomeModule,
                        ShareButton
                    ]
                }]
        }], null, null); })();

    exports.ShareButton = ShareButton;
    exports.ShareButtonModule = ShareButtonModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-share-button.umd.js.map
