import { BehaviorSubject } from 'rxjs';
import { ShareButtonsConfig } from './share.models';
import * as i0 from "@angular/core";
export declare class ShareService {
    /** Global config that applies on all share buttons in the app */
    config: ShareButtonsConfig;
    /** Stream that emits when config changes */
    config$: BehaviorSubject<ShareButtonsConfig>;
    constructor(config: ShareButtonsConfig);
    /**
     * Share buttons properties, used to get the text, color and icon of each button.
     */
    get prop(): import("./share.models").IShareButtons;
    get windowSize(): string;
    setConfig(config: ShareButtonsConfig): void;
    static ɵfac: i0.ɵɵFactoryDef<ShareService, [{ optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDef<ShareService>;
}
